#==========================================================================
# 		BOOTSTRAP EPOCH METHODS
#==========================================================================getwd()
source(file.path(WERinR,"Recipes/EVA/EVA-functions.R"))
Print<-function(x) {cat(x,"\n");  flush.console()}

qgev=function(gev,P){gev[1]+gev[2]/gev[3]*((-log(P))^-gev[3]-1)}

# Select Weibull indices to be run
ws<-c(0.75,0.9,1,1.1,1.25,1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75,4)

wfile<-"Nextw.Rdata"
if (file.exists(wfile))
 {load(wfile)
  if(iw>length(ws)) 
   stop("Bootstrap complete - Consolidate files")
  w<-ws[iw]
  iw<-iw+1
  save(iw,file=wfile)
 }else{
  w<-ws[1]
  iw<-2
  save(iw,file=wfile)
 }

if (!(iw-1)>length(ws))
{#
Print(paste("Bootstrapping Epoch methods for w =",w))

Rs=c(10,15,20,25,30,40,50,60,70,80,90,100)
PIs=c(1.5,2:15)
T=1e4

plotit=FALSE

nR<-length(Rs)
nPI<-length(PIs)
y50<--log(-log(1-1/50))
y100<--log(-log(1-1/100))
y1000<--log(-log(1-1/1000))
y10000<--log(-log(1-1/10000))
P50<-1-1/50
P100<-1-1/100
P1000<-1-1/1000
P10000<-1-1/10000
Means<-numeric()
Variances<-numeric()

boot=function(r,i)
{Z<-data.frame(Ugrg=numeric(),Dgrg=numeric(),wgrg=numeric(),
    Ugrw=numeric(),Dgrw=numeric(),wgrw=numeric(),
    Ugev=numeric(),Dgev=numeric(),shp=numeric(),
    X50=numeric(),W50=numeric(),G50=numeric(),
    X100=numeric(),W100=numeric(),G100=numeric(),
    X1000=numeric(),W1000=numeric(),G1000=numeric(),
    X10000=numeric(),W10000=numeric(),G10000=numeric())
 Print(paste("R =",Rs[r],"PI =",PIs[i]))
 y<-y.gring.mean(Rs[r])
 P<-exp(-exp(-y))
 for (t in c(1:T))
 {V<-sort(rgumb(Rs[r],PIs[i],1,w),decreasing=TRUE)
  grg<-as.numeric(EVA.epoch.fit(V,"GRG",w=w))
  Vgrg<-qximis(y,grg)
  gev<-epoch.GEV(V)$par
  Vgev<-qgev(gev,P)
  grw<-as.numeric(EVA.epoch.fit(V,"GRW"))
  Vgrw<-qximis(y,grw)
  if (plotit)
   {plot(y,sort(V,decreasing=TRUE))
    lines(y,Vgrg,lwd=3)
    lines(y,Vgev,lwd=3,col="red")
    lines(y,Vgrw,lwd=3,col="blue")
    Vtgt<-qximis(y,c(PIs[i],1,w))
    lines(y,Vtgt,col="green")
   }
  z<-data.frame(Ugrg=grg[1],Dgrg=grg[2],wgrg=grg[3],
      Ugrw=grw[1],Dgrw=grw[2],wgrw=grw[3],
      Ugev=gev[1],Dgev=gev[2],shp=gev[3],
      X50=qximis(y50,grg),W50=qximis(y50,grw),G50=qgev(gev,P50),
      X100=qximis(y100,grg),W100=qximis(y100,grw),G100=qgev(gev,P100),
      X1000=qximis(y1000,grg),W1000=qximis(y1000,grw),G1000=qgev(gev,P1000),
      X10000=qximis(y10000,grg),W10000=qximis(y10000,grw),G10000=qgev(gev,P10000)
     )
  Z<-rbind(Z,z)
 }
 means<-c(Rs[r],PIs[i],colMeans(Z))
 names(means)<-c("R","PI",colnames(Z))
 variances<-c(Rs[r],PIs[i],apply(Z,2,var))
 names(variances)<-c("R","PI",colnames(Z))
 return(c(means,variances))
}

r<-c(1:nR)
tic<-Sys.time()
Out<-numeric()
for (i in c(1:nPI))
{out<-t(sapply(r,boot,i=i))
 Out<-rbind(Out,out)
}
print(Sys.time()-tic)

Means<-as.data.frame(Out[,1:23])
Variances<-as.data.frame(Out[,24:46])
rownames(Means)<-NULL
rownames(Variances)<-NULL

save(Means,Variances,file=paste("BootData\\EpochBoot.w",w,".Rdata",sep=""))


#round(Means,4)
#round(Variances,4)




