#==========================================================================
# 		BOOTSTRAP SENSITIVITY TO WEIBULL INDEX 
#==========================================================================
 getwd()
 source(file.path(WERinR,"Recipes/EVA/EVA-functions.R"))
 Print<-function(x) {cat(x,"\n");  flush.console()}

library(evir)


R=20		# Tne number of epochs for this batch of runs

# Select Weibull indices to be run
ws<-c(0.75,0.9,1,1.1,1.25,1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75,4)

wfile<-"Nextw.Rdata"
if (file.exists(wfile))
 {load(wfile)
  if(iw>length(ws)) 
   stop("Bootstrap complete - Consolidate files")
  w<-ws[iw]
  iw<-iw+1
  save(iw,file=wfile)
 }else{
  w<-ws[1]
  iw<-2
  save(iw,file=wfile)
 }

if (!(iw-1)>length(ws))
{#
Print(paste("Bootstrapping POT methods for w =",w))

Ms<-c(100)		# Number of values over threshold
PIs=c(1.5,2:15)				# Characteristic product
T=1e4						#Number of trials

plotit=FALSE

nM<-length(Ms)
nPI<-length(PIs)

boot=function(m,i)
{Z<-data.frame(Uw=numeric(),Dw=numeric(),
  	 Up10=numeric(),Dp10=numeric(),
 	 Up20=numeric(),Dp20=numeric(),
 	 Up30=numeric(),Dp30=numeric(),
 	 Up50=numeric(),Dp50=numeric(),
  	 Um10=numeric(),Dm10=numeric(),
 	 Um20=numeric(),Dm20=numeric(),
 	 Um30=numeric(),Dm30=numeric(),
 	 Um50=numeric(),Dm50=numeric())
 Print(paste("M =",Ms[m],"PI =",PIs[i]))
 for (t in c(1:T))
 {V<-sort(rximis(Ms[m],R,PIs[i],1,w),decreasing=TRUE)
  z<-data.frame(Uw=0,Dw=0,
  	 Up10=0,Dp10=0,
 	 Up20=0,Dp20=0,
 	 Up30=0,Dp30=0,
 	 Up50=0,Dp50=0,
  	 Um10=0,Dm10=0,
 	 Um20=0,Dm20=0,
 	 Um30=0,Dm30=0,
 	 Um50=0,Dm50=0)
  xms<-c(summary(pot.XMS(V,R,w))$coefficients[1:2]^(1/w),w)
  z$Uw<-xms[1]; z$Dw<-xms[2]
  xms<-c(summary(pot.XMS(V,R,w*1.1))$coefficients[1:2]^(1/w/1.1),w*1.1)
  z$Up10<-xms[1]; z$Dp10<-xms[2] 
  xms<-c(summary(pot.XMS(V,R,w*1.2))$coefficients[1:2]^(1/w/1.2),w*1.2)
  z$Up20<-xms[1]; z$Dp20<-xms[2] 
  xms<-c(summary(pot.XMS(V,R,w*1.3))$coefficients[1:2]^(1/w/1.3),w*1.3)
  z$Up30<-xms[1]; z$Dp30<-xms[2] 
  xms<-c(summary(pot.XMS(V,R,w*1.5))$coefficients[1:2]^(1/w/1.5),w*1.5)
  z$Up50<-xms[1]; z$Dp50<-xms[2] 
  xms<-c(summary(pot.XMS(V,R,w/1.1))$coefficients[1:2]^(1/w*1.1),w/1.1)
  z$Um10<-xms[1]; z$Dm10<-xms[2] 
  xms<-c(summary(pot.XMS(V,R,w/1.2))$coefficients[1:2]^(1/w*1.2),w/1.2)
  z$Um20<-xms[1]; z$Dm20<-xms[2] 
  xms<-c(summary(pot.XMS(V,R,w/1.3))$coefficients[1:2]^(1/w*1.3),w/1.3)
  z$Um30<-xms[1]; z$Dm30<-xms[2] 
  xms<-c(summary(pot.XMS(V,R,w/1.5))$coefficients[1:2]^(1/w*1.5),w/1.5)
  z$Um50<-xms[1]; z$Dm50<-xms[2] 
  Z<-rbind(Z,z)
 }
 means<-c(Ms[m],PIs[i],colMeans(Z))
 names(means)<-c("M","PI",colnames(Z))
 variances<-c(Ms[m],PIs[i],apply(Z,2,var))
 names(variances)<-c("M","PI",colnames(Z))
 return(c(means,variances))
}

m<-c(1:nM)
tic<-Sys.time()
Out<-numeric()
for (i in c(1:nPI))
{out<-t(sapply(m,boot,i=i))
 Out<-rbind(Out,out)
}
print(Sys.time()-tic)

Means<-as.data.frame(Out[,1:20])
Variances<-as.data.frame(Out[,21:40])
rownames(Means)<-NULL
rownames(Variances)<-NULL

save(Means,Variances,file=paste("BootData\\Wsens.w",w,".R",R,".Rdata",sep=""))
}#

#round(Means,4)
#round(Variances,4)



