
getwd()


print(load("EpochBoot.Rdata"))
Epoch.means<-means[means$w>=1,]
Epoch.variances<-variances[variances$w>=1,]

print(load("PotBoot.R20.Rdata"))
Pot.R20.means<-means[means$w>=1,]
Pot.R20.variances<-variances[variances$w>=1,]

print(load("PotBoot.R50.Rdata"))
Pot.R50.means<-means[means$w>=1,]
Pot.R50.variances<-variances[variances$w>=1,]


print(load("WeibPotBoot.R20.Rdata"))
Weib.R20.means<-means[means$w>=1,]
Weib.R20.variances<-variances[variances$w>=1,]
print(load("WeibPotBoot.R50.Rdata"))
Weib.R50.means<-means[means$w>=1,]
Weib.R50.variances<-variances[variances$w>=1,]

R=20
Ep.sd<-sqrt(colMeans(Epoch.variances[Epoch.variances$R==20,]))
Pot.R20.sd<-sqrt(colMeans(Pot.R20.variances[Pot.R20.variances$M==100,]))
Pot.R50.sd<-sqrt(colMeans(Pot.R50.variances))

print(round(Ep.sd[13:24],3))
print(round(Pot.R20.sd[15:26],3))

Weib.R20.sd<-sqrt(colMeans(Weib.R20.variances))
Weib.R50.sd<-sqrt(colMeans(Weib.R50.variances))




SVG=FALSE
graphics.off()

#=======================================================================================================
# 			EPOCH QQ plot 
#=======================================================================================================
#for (R in unique(Epoch.means$R))
R=20
#for (MRI in c(50,100,1000,10000))
for (MRI in c(50,10000))
{if(SVG) {svg(paste("QQstderr.Epoch.R",R,".",MRI,".svg",sep=""))}else{dev.new()}
 y<--log(-log(1-1/MRI))
 xname<-paste("X",MRI,sep="")
 X<-Epoch.means[Epoch.means$R==R,xname]
 yname<-paste("G",MRI,sep="")
 plot(sqrt(Epoch.variances[Epoch.variances$R==R,xname])/X,sqrt(Epoch.variances[Epoch.variances$R==R,yname])/X,col="red",lwd=2,
  xlab="Standard error of Gringorten using source index",
  ylab="Standard error of method",
  main="Comparison of Epoch method standard error")
 mtext(bquote(.(R)~" Epochs, Mean recurrence interval = "~.(MRI)))
 abline(-0,1,lwd=2)
 yname<-paste("W",MRI,sep="")
 points(sqrt(Epoch.variances[Epoch.variances$R==R,xname])/X,sqrt(Epoch.variances[Epoch.variances$R==R,yname])/X,
  col="blue",lwd=2,pch=0,cex=0.8)
 legend("topleft",c("GEV","GRG, fitting index","Datum: GRG, source index"),
  pch=c(1,0,NA),col=c("red","blue","black"),bg="white",box.col="white",lwd=c(NA,NA,2),pt.lwd=2)
 box()
 if (SVG) dev.off()
}


#=======================================================================================================
# 			POT QQ plot for R=20
#=======================================================================================================
#for (MRI in c(50,100,1000,10000))
for (MRI in c(50,10000))
{if(SVG) {svg(paste("QQstderr.POT.R20.",MRI,".svg",sep=""))}else{dev.new()}
 y<--log(-log(1-1/MRI))
 xname<-paste("X",MRI,sep="")
 X<-Pot.R20.means[,xname]
 yname<-paste("G",MRI,sep="")
 plot(sqrt(Pot.R20.variances[,xname])/X,sqrt(Pot.R20.variances[,yname])/X,col="red",lwd=2,
  xlab="Standard error of XIMIS using source index",
  ylab="Standard error of method",
  main="Comparison of POT method standard error")
  mtext(bquote(.(R)~" Epochs, Mean recurrence interval = "~.(MRI)))
 abline(-0,1,lwd=2)
 yname<-paste("W",MRI,sep="")
 points(sqrt(Pot.R20.variances[,xname])/X,sqrt(Pot.R20.variances[,yname])/X,col="blue",lwd=2,pch=0,cex=0.8)
 legend("topleft",c("GPD","XIMIS, fitting index","Datum: XIMIS, source index"),
  pch=c(1,0,NA),col=c("red","blue","black"),bty="n",lwd=c(NA,NA,2),pt.lwd=2)
 if (SVG) dev.off()
}

#=======================================================================================================
# 			POT QQ plot for R=50
#=======================================================================================================
for (MRI in c(50,100,1000,10000))
{if(SVG) {svg(paste("QQstderr.POT.R50.",MRI,".svg",sep=""))}else{dev.new()}
 y<--log(-log(1-1/MRI))
 xname<-paste("X",MRI,sep="")
 X<-Pot.R50.means[,xname]
 yname<-paste("G",MRI,sep="")
 plot(sqrt(Pot.R50.variances[,xname])/X,sqrt(Pot.R50.variances[,yname])/X,col="red",lwd=2,
  xlab="Standard error of XIMIS using source index",
  ylab="Standard error of method",
  main="Comparison of POT method standard error")
 mtext(bquote("50 Epochs, MRI = "~.(MRI)))
 abline(-0,1,lwd=2)
 yname<-paste("W",MRI,sep="")
 points(sqrt(Pot.R50.variances[,xname])/X,sqrt(Pot.R50.variances[,yname])/X,col="blue",lwd=2,pch=0,cex=0.8)
 legend("topleft",c("GPD","XIMIS, fitting index","Datum: XIMIS, source index"),
  pch=c(1,0,NA),col=c("red","blue","black"),bty="n",lwd=c(NA,NA,2),pt.lwd=2)
 if (SVG) dev.off()
}

#=======================================================================================================
# 			Weib-POT QQ plot for R=20
#=======================================================================================================
#for (MRI in c(50,100,1000,10000))

Wbm<-Weib.R20.means[Weib.R20.means$r>6,]
Wbv<-Weib.R20.variances[Weib.R20.variances$r>6,]
graphics.off()
for (MRI in c(50,10000))
{if(SVG) {svg(paste("QQstderr.Weib.R20.",MRI,".svg",sep=""))}else{dev.new()}
 y<--log(-log(1-1/MRI))
 xname<-paste("X",MRI,sep="")
 X<-Pot.R20.means[,xname]
 yname<-paste("W",MRI,sep="")
 plot(sqrt(Pot.R20.variances[,xname])/X,sqrt(Pot.R20.variances[,yname])/X,col="grey",lwd=2,
  xlab="Standard error of XIMIS using source index",cex=0.5,
  ylab="Standard error of method",
  main="Comparison of POT method standard error")
  mtext(bquote(.(R)~" Epochs, Mean recurrence interval = "~.(MRI)))
 abline(-0,1,lwd=2)
 X<-(Wbm$Uxms^Wbm$w+y*Wbm$Dxms^Wbm$w)^(1/Wbm$w)
 yname<-paste("O",MRI,sep="")
 points(sqrt(Wbv[,xname])/X,sqrt(Wbv[,yname])/X,col="green4",lwd=2,pch=2,cex=0.8)
 yname<-paste("P",MRI,sep="")
 points(sqrt(Wbv[,xname])/X,sqrt(Wbv[,yname])/X,col="blue",lwd=2,pch=0,cex=0.8)
 legend("topleft",c("XIMIS, fitting index","Weib-XIMIS, N=rR",
                      "Weib-XIMIS, optimised w","Datum: XIMIS, source index"),pt.cex=c(0.5,0.8,0.8,NA),
  pch=c(1,0,2,NA),col=c("grey","blue","green4","black"),bty="n",lwd=c(NA,NA,NA,2),pt.lwd=2)
 if (SVG) dev.off()
}




#=======================================================================================================
# 			GEV QQ plot 
#=======================================================================================================
print(load("GEVBoot.Rdata"))
GEV.means<-means[means$w>=1,]
GEV.variances<-variances[variances$w>=1,]


#for (R in unique(Epoch.means$R))
R=20
#for (MRI in c(50,100,1000,10000))
for (MRI in c(50,10000))
{if(SVG) {svg(paste("QQstderr.GEV.R",R,".",MRI,".svg",sep=""))}else{dev.new()}
 y<--log(-log(1-1/MRI))
 xname<-paste("X",MRI,sep="")
 X<-GEV.means[GEV.means$R==R,xname]
 yname<-paste("G",MRI,sep="")
 plot(sqrt(GEV.variances[GEV.variances$R==R,xname])/X,sqrt(GEV.variances[GEV.variances$R==R,yname])/X,col="red",lwd=2,
  xlab="Standard error of Gringorten using source index",
  ylab="Standard error of method",
  main="Comparison of Epoch method standard error from GEV source")
 mtext(bquote(.(R)~" Epochs, Mean recurrence interval = "~.(MRI)))
 abline(-0,1,lwd=2)
 yname<-paste("W",MRI,sep="")
 points(sqrt(GEV.variances[GEV.variances$R==R,xname])/X,sqrt(GEV.variances[GEV.variances$R==R,yname])/X,
  col="blue",lwd=2,pch=0,cex=0.8)
 legend("topleft",c("GEV","GRG, fitting index","Datum: GRG, source index"),
  pch=c(1,0,NA),col=c("red","blue","black"),bg="white",box.col="white",lwd=c(NA,NA,2),pt.lwd=2)
 box()
 if (SVG) dev.off()
}






#=======================================================================================================
# 			Characteristic product vs log rate
#=======================================================================================================

Wbm<-Weib.R20.means[Weib.R20.means$r>6,]
Wbv<-Weib.R20.variances[Weib.R20.variances$r>6,]
graphics.off()
if(SVG) {svg(paste("QQ.PI.lnr.svg",sep=""))}else{dev.new()}
X<-log(Wbm$r)
Y<-(Wbm$Uxms/Wbm$Dxms)^Wbm$w
 plot(X,Y,col="red",lwd=2,
  xlab=expression(ln(italic(r))),
  ylab=expression(Pi^w),cex=1.5,
  main="Characteristic product from rate per epoch")
abline(0,1,lwd=2)
#  abline(lm(Y~X),lwd=3,col="red",lty=2)
Y<-(Wbm$Uxmp/Wbm$Dxmp)^Wbm$wxmp
 points(X,Y,pch=0,cex=1,lwd=2,col="blue")
  abline(lm(Y~X),lwd=3,col="blue",lty=4)
Y<-(Wbm$Uxmo/Wbm$Dxmo)^Wbm$wxmo
 points(X,Y,pch=2,cex=1,lwd=2,col="green4")
  abline(lm(Y~X),lwd=3,col="green4",lty=3)
mtext(expression("Datum: "~Pi^italic(w)==ln(italic(r))))
 legend("topleft",c("XIMIS, source w","Weib-XIMIS, N=rR",
                      "Weib-XIMIS, optimised w","Datum"),pt.cex=c(1.5,1,1,NA),
  pch=c(1,0,2,NA),col=c("red","blue","green4","black"),bty="n",lwd=c(NA,NA,NA,2),pt.lwd=2)
 if (SVG) dev.off()









